
----------- variables de type FONCTION ----------
function ActiveMonstre(iAM)
  if not monstre[iAM].ok then
    timer[iAM]:start()
    if timer[iAM]:time() >= 1000 then
      monstre[iAM].x = math.random(256 - monstre[iAM].largeur)
      monstre[iAM].y = math.random(192 - monstre[iAM].hauteur)
      monstre[iAM].ok = true
    end
  end
end

function DeplaceMonstres() 
   for nombre = 1,7 do
      if monstre[nombre].ok then
         local direction = math.random(4)
         if direction == 1 then 
            monstre[nombre].x = monstre[nombre].x + 1
            elseif direction == 2 then
               monstre[nombre].x = monstre[nombre].x - 1
            elseif direction == 3 then
               monstre[nombre].y = monstre[nombre].y + 1
            elseif direction == 4 then
               monstre[nombre].y = monstre[nombre].y - 1
         end
      end
   end
end   
                   
function ReinitialiseGame()
   cible.x = 256/2 - (cible.largeur/2)   
   cible.y = 192/2 - (cible.hauteur/2)
   score.malus = true
   score.actuel = 0
   munitions = 55
   explosion.ok = false
   son.perdu = true   
   son.victoire = true   
   son.croq = true  
         
   if victoire then          
      Image.destroy(victoireImage)
      victoireImage = nil
      victoire = false
      elseif perdu then
         Image.destroy(perduImage)   
         perduImage = nil
         perdu = false
   end
   
   victoireAffichage = true   
   perduAffichage = true   
  
   for iTM = 1,7 do
      timer[iTM]:reset()
      timer[iTM]:stop()
   end
   
   tmr:reset()
   tmr:start()
end
        
   
-- VARIABLES --
monstre = {}
timer = {}

cible = {}
   cible.image = Image.load("images/cible.png",VRAM)
   cible.largeur = Image.width(cible.image)
   cible.hauteur = Image.height(cible.image)
   cible.x = 256/2 - (cible.largeur/2)   
   cible.y = 192/2 - (cible.hauteur/2)   
   cible.vitesse = 2
   
for iV = 1,7 do
  monstre[iV] = {}
    monstre[iV].image = Image.load("images/monstre"..iV..".png",VRAM)
    monstre[iV].largeur = Image.width(monstre[iV].image)
    monstre[iV].hauteur = Image.height(monstre[iV].image)
    monstre[iV].x = math.random(256 - monstre[iV].largeur)
    monstre[iV].y = math.random(192 - monstre[iV].hauteur)
    monstre[iV].ok = false
end
         
explosion = {} 
   explosion.image = Image.load("images/explosion.png",VRAM)
   explosion.x = 0
   explosion.y = 0
   explosion.ok = false
      
son = {}   
   son.perdu = true   
   son.victoire = true     
   son.croq = true   
   
score = {}
   score.actuel = 0
   score.gestion = INI.load("highscore.ini")
   score.malus = true  -- pour grer la diminution du score en cas de dfaite
   score.max = tonumber(score.gestion["high"]["score"])
         
background = Image.load("images/background.jpg",VRAM)

victoire = false
victoireAffichage = true  -- pour grer le chargement de l'image de victoire dans la boucle de jeu : solution pour contourner le manque de VRAM.

perdu = false
perduAffichage = true -- idem que victoireAffichage

munitions = 55
   
Sound.loadBank("sons/soundbank.bin")
for i = 0,5 do Sound.loadSFX(i) end

tmr = Timer.new()  -- temps de jeu
for iT = 1,7 do
  timer[iT] = Timer.new()
end
tmr:start()


------------------ JEU -------------------
while not Keys.held.Select do
   Controls.read()   
   DeplaceMonstres()
   
   --1. Dplacement de la cible
   if Keys.held.Left then     -- sur les cts
      cible.x = cible.x - cible.vitesse
      elseif Keys.held.Right then
         cible.x = cible.x + cible.vitesse
   end
   if Keys.held.Up then       -- en haut et en bas
      cible.y = cible.y - cible.vitesse
      elseif Keys.held.Down then
         cible.y = cible.y + cible.vitesse
   end
   
   if cible.x > 256 then     --Pour que la cible rapparaisse de l'autre ct quand on sort de l'cran
      cible.x = 0
      elseif cible.x + cible.largeur < 0 then   
         cible.x = 256
   end
   if cible.y > 192 then 
      cible.y = 0 
      elseif cible.y + cible.largeur < 0 then 
         cible.y = 192 
   end 
   
   --2.1 Apparition des ennemis
   for iAP = 1,7 do
     if tmr:time() > (iAP-1)*5000 then 
        ActiveMonstre(iAP)
        if monstre[iAP].ok then
           if timer[iAP]:time() > 5000 then perdu = true end          
        end
     end
   end
    
   --2.2 On empche aux monstres de dborder de l'cran
   for iDBE = 1,7 do
     if monstre[iDBE].x < 0 then 
        monstre[iDBE].x = 0
        elseif monstre[iDBE].x + monstre[iDBE].largeur > 256 then
           monstre[iDBE].x = 256 - monstre[iDBE].largeur
     end
     if monstre[iDBE].y < 0 then
        monstre[iDBE].y = 0
        elseif monstre[iDBE].y + monstre[iDBE].hauteur > 192 then
           monstre[iDBE].y = 192 - monstre[iDBE].hauteur
     end
   end
   
   --3. Gestion du tir
   if Keys.newPress.A then
      if not perdu and not victoire then
         if munitions > 0 then
            munitions = munitions - 1
            Sound.startSFX(5)    -- Son du tir
            
            for iGT = 1,7 do
              if monstre[iGT].ok then
                 if cible.x + cible.largeur/2 >= monstre[iGT].x and cible.x + cible.largeur/2 <= monstre[iGT].x + monstre[iGT].largeur and cible.y + cible.hauteur/2 >= monstre[iGT].y and cible.y + cible.hauteur/2 <= monstre[iGT].y + monstre[iGT].hauteur then
                    monstre[iGT].ok = false
                    explosion.x = monstre[iGT].x + ((monstre[iGT].largeur-Image.width(explosion.image)))/2   --pour centrer la tache de sang
                    explosion.y = monstre[iGT].y + ((monstre[iGT].hauteur-Image.height(explosion.image)))/2
                    explosion.ok = true
                    Sound.startSFX(4)    --projection de sang
                    timer[iGT]:reset()
                    score.actuel = score.actuel + 1
                 end
              end
            end
            
            else Sound.startSFX(1)   -- munitions vides
         end
      end
   end
   
   --4. Pour gagner
   if tmr:time() >= 40000 then
      victoire = true  
      if victoireAffichage then
         victoireImage = Image.load("images/victoire.png",VRAM)
         victoireAffichage = false
      end   
      if son.victoire then   
         Sound.startSFX(3)
         son.victoire = false
      end
   end
   
   --5. Si on perd
   if perdu then 
      if score.malus then
         score.actuel = score.actuel - 5   --on pnalise la dfaite
         score.malus = false
      end
      if son.croq then
         Sound.startSFX(0)   --bruit de morsure
         son.croq = false
      end
      if son.perdu then
         Sound.startSFX(2)   --rire de femme
         son.perdu = false
      end
      if perduAffichage then
         perduImage = Image.load("images/perdu.png",VRAM)
         perduAffichage = false
      end
   end
   
   --6. Pour rejouer
   if victoire or perdu then
      tmr:stop()
      
      if score.actuel > score.max then        -- Changement du highscore
         score.max = score.actuel
      end
      
      for iS = 1,7 do
        timer[iS]:stop()
        monstre[iS].ok = false
      end
      
      if Keys.held.Start then ReinitialiseGame() end
   end
        
   -- AFFICHAGE --
   screen.print(SCREEN_DOWN,0,0,"Select pour quitter en sauvegardant")
   screen.print(SCREEN_DOWN,0,50,"Temps coul : "..tmr:time()/1000 .."s")
   screen.print(SCREEN_DOWN,0,80,"Munitions : "..munitions)     
   screen.print(SCREEN_DOWN,0,110,"Score : "..score.actuel)
   screen.print(SCREEN_DOWN,0,130,"Highscore : "..score.max)  
   
   if not perdu and not victoire then
      screen.blit(SCREEN_UP,256/2 - Image.width(background)/2,192/2 - Image.height(background)/2,background)
      
      if explosion.ok then screen.blit(SCREEN_UP,explosion.x,explosion.y,explosion.image) end
      
      for i = 1,7 do
         if monstre[i].ok then 
            screen.blit(SCREEN_UP,monstre[i].x,monstre[i].y,monstre[i].image) 
         end
      end
      
      screen.blit(SCREEN_UP,cible.x,cible.y,cible.image)
      
      elseif perdu then 
         screen.blit(SCREEN_UP,256/2 - Image.width(perduImage)/2,192 - Image.height(perduImage),perduImage) 
         screen.print(SCREEN_DOWN,10,180,"Start pour rejouer")
      elseif victoire then
         screen.blit(SCREEN_UP,0,0,victoireImage) 
         screen.print(SCREEN_DOWN,10,180,"Start pour rejouer")
   end
      
   render()
end
score.gestion["high"]["score"] = tostring(score.max)
INI.save("highscore.ini",score.gestion)   --enregistrement du highscore
   
   
-- VIDAGE DE LA MEMOIRE --
Image.destroy(cible.image)  
Image.destroy(background)
Image.destroy(explosion.image)

for iD = 1,7 do
  Image.destroy(monstre[iD].image)
end

if perdu then
   Image.destroy(perduImage)
elseif victoire then
   Image.destroy(victoireImage)
end

for i = 0,5 do Sound.unloadSFX(i) end
Sound.unloadBank()

cible = nil
explosion = nil
monstre = nil
son = nil
tmr, timer = nil
score = nil

perdu, perduImage = nil, nil, nil
victoire, victoireImage = nil, nil
victoireAffichage, perduAffichage = nil, nil
munitions, background = nil, nil

ActiveMonstre = nil
DeplaceMonstres = nil
ReinitialiseGame = nil

collectgarbage()
